﻿Imports System.Runtime.InteropServices

Public Class ByteConvert

    Public Shared Function ToStruct(ByVal data As Byte(), ByVal structType As Type) As Object

        Dim MyGC As GCHandle = GCHandle.Alloc(data, GCHandleType.Pinned)
        Dim struct As Object = Marshal.PtrToStructure(MyGC.AddrOfPinnedObject, structType)

        MyGC.Free()

        Return struct

    End Function

    Public Shared Function ToBytes(ByVal struct As Object, ByVal structType As Type) As Byte()

        Dim Ptr As IntPtr = Marshal.AllocHGlobal(Marshal.SizeOf(struct))
        Dim bytes(Marshal.SizeOf(struct) - 1) As Byte

        Marshal.StructureToPtr(struct, Ptr, False)
        Marshal.Copy(Ptr, bytes, 0, Marshal.SizeOf(struct))

        Marshal.FreeHGlobal(Ptr)

        Return bytes

    End Function
End Class
