﻿Imports System.Runtime.InteropServices

Namespace structs

    <StructLayout(LayoutKind.Sequential)> _
    Public Class LoggerRequest
        Public Start_1 As UInt16
        Public Start_2 As UInt16
        Public StructType As UInt16
        Public StructLength As UInt16

        Public StartSecs As UInt32
        Public StopSecs As UInt32
        Public StartMSecs As UInt16
        Public StopMSecs As UInt16
    End Class

    <StructLayout(LayoutKind.Sequential)> _
    Public Class LoggerNoAccess
        Public Start_1 As UInt16
        Public Start_2 As UInt16
        Public StructType As UInt16
        Public StructLength As UInt16

        Public LoggerState As UInt32
    End Class

    <StructLayout(LayoutKind.Explicit)> _
    Public Class LoggerCheck
        <FieldOffset(0)> Public Start_1 As UInt16
        <FieldOffset(2)> Public Start_2 As UInt16
        <FieldOffset(4)> Public StructType As UInt16
        <FieldOffset(6)> Public StructLength As UInt16

        <FieldOffset(8)> Public LoggerState As UInt32
        <FieldOffset(12)> Public MemorySize As UInt32
        <FieldOffset(16)> Public MemoryProgress As UInt32
    End Class

    <StructLayout(LayoutKind.Sequential)> _
    Public Class LoggerDataRequest
        Public Start_1 As UInt16
        Public Start_2 As UInt16
        Public StructType As UInt16
        Public StructLength As UInt16
    End Class

    <StructLayout(LayoutKind.Explicit)> _
    Public Class LoggerDataSet
        <FieldOffset(0)> Public Start_1 As UInt16
        <FieldOffset(2)> Public Start_2 As UInt16
        <FieldOffset(4)> Public StructType As UInt16
        <FieldOffset(6)> Public StructLength As UInt16
        <FieldOffset(8)> Public MaxCount As UInt32
        <FieldOffset(12)> Public ProcessCount As UInt32
        <FieldOffset(16)> Public TimeSecs As UInt32
        <FieldOffset(20)> Public TimeMSecs As UInt32
        <FieldOffset(24)> Public OutputState As UInt16
        <FieldOffset(26)> Public InputState As UInt16
        <FieldOffset(28)> Public Reserved As UInt32
        <FieldOffset(32)> Public Alarms As UInt32

        <FieldOffset(36)> _
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=6)> Public CounterValue(5) As UInt32

        <FieldOffset(60)> _
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=3)> Public CounterError(2) As UInt32
    End Class

End Namespace
