﻿Imports System.Net
Imports System.Net.Sockets

Public Class Form1

    Dim TCP_Client As Socket
    Dim receiveBuffer(511) As Byte
    Dim lastReceive(511) As Byte

    Dim baseDate As DateTime = DateTime.Parse("1.1.70 00:00:00")

    Private Delegate Sub DelegateSub()



    Private Sub bt_connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_connect.Click

        If Me.ed_IP.Text <> "" And Me.ed_Port.Text <> "" Then

            Try

                Dim RemoteEP As New IPEndPoint(IPAddress.Parse(Me.ed_IP.Text), Integer.Parse(Me.ed_Port.Text))
                Me.TCP_Client = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)

                Me.Invoke(New DelegateSub(AddressOf connectdisable))

                Me.TCP_Client.BeginConnect(RemoteEP, New AsyncCallback(AddressOf callback_connect), TCP_Client)

                Me.ProgressBar1.Value = 0
                Me.lw_receive.Items.Clear()

            Catch ex As Exception
                Me.sb_status.Text = "Error while connecting!"
            End Try
        End If

    End Sub

    Private Sub callback_connect(ByVal ar As IAsyncResult)
        Try

            TCP_Client.EndConnect(ar)

            Me.sb_status.Text = "connected"

            Me.Invoke(New DelegateSub(AddressOf connectdisable))
            TCP_Client.BeginReceive(receiveBuffer, 0, 72, SocketFlags.None, New AsyncCallback(AddressOf callback_receive), TCP_Client)


            Try
                Dim cmd As Byte()
                Dim LoggerRequest As New structs.LoggerRequest
                LoggerRequest.Start_1 = 0
                LoggerRequest.Start_2 = 0
                LoggerRequest.StructType = &H1E0
                LoggerRequest.StructLength = 20
                LoggerRequest.StartSecs = DateDiff("s", "1.1.70 00:00:00", _
                       ed_day0.Text + "." + ed_month0.Text + "." + ed_year0.Text + _
                        " " + ed_hour0.Text + ":" + ed_minute0.Text + ":" + ed_second0.Text) - Val(ed_utcoffset.Text) * 3600

                Dim startDate As New DateTime(Me.ed_year0.Text, Me.ed_month0.Text, Me.ed_day0.Text, Me.ed_hour0.Text, Me.ed_minute0.Text, Me.ed_second0.Text)
                Dim stopDate As New DateTime(Me.ed_year1.Text, Me.ed_month1.Text, Me.ed_day1.Text, Me.ed_hour1.Text, Me.ed_minute1.Text, Me.ed_second1.Text)

                LoggerRequest.StartSecs = startDate.Subtract(baseDate).TotalSeconds - Integer.Parse(ed_utcoffset.Text) * 3600
                LoggerRequest.StopSecs = stopDate.Subtract(baseDate).TotalSeconds - Integer.Parse(ed_utcoffset.Text) * 3600
                LoggerRequest.StopSecs = DateDiff("s", "1.1.70 00:00:00", _
                        ed_day1.Text + "." + ed_month1.Text + "." + ed_year1.Text + _
                        " " + ed_hour1.Text + ":" + ed_minute1.Text + ":" + ed_second1.Text) - Val(ed_utcoffset.Text) * 3600

                LoggerRequest.StartMSecs = 0
                LoggerRequest.StopMSecs = 0

                cmd = ByteConvert.ToBytes(LoggerRequest, GetType(structs.LoggerRequest))
                Me.TCP_Client.Send(cmd, cmd.Length, SocketFlags.None)

                Me.ProgressBar1.Value = 0


            Catch ex As Exception
                closeConnection()
                Me.sb_status.Text = "Error while LoggerRequest"
            End Try

        Catch ex As Exception
            closeConnection()
            Me.sb_status.Text = "Error while connecting!"
        End Try
    End Sub

    Private Sub callback_receive(ByVal ar As IAsyncResult)

        Dim receiveCount As Integer = 0

        Try
            If Not TCP_Client Is Nothing Then
                If TCP_Client.Connected Then
                    receiveCount = TCP_Client.EndReceive(ar)
                    Array.Copy(receiveBuffer, Me.lastReceive, 511)
                    Array.Clear(receiveBuffer, 0, 512)
                    Me.Invoke(New DelegateSub(AddressOf evaluateResponse))
                    TCP_Client.BeginReceive(receiveBuffer, 0, 72, SocketFlags.None, New AsyncCallback(AddressOf callback_receive), TCP_Client)
                End If
            End If
        Catch ex As Exception
            closeConnection()
            Me.sb_status.Text = "Error while receiving!"
        End Try

        If receiveCount = 0 Then
            closeConnection()
        End If

    End Sub

    Private Sub closeConnection()

        Try
            If Not TCP_Client Is Nothing Then
                If TCP_Client.Connected Then
                    TCP_Client.Shutdown(SocketShutdown.Both)
                    TCP_Client.Close()
                    TCP_Client = Nothing
                End If
            End If

            Me.sb_status.Text = "no connection"

            Me.Invoke(New DelegateSub(AddressOf connectenable))
        Catch ex As Exception
            Me.sb_status.Text = "Error while disconnecting!"
        End Try

    End Sub

    Private Sub connectdisable()

        Me.bt_connect.Enabled = False

    End Sub

    Private Sub connectenable()

        Me.bt_connect.Enabled = True

    End Sub

    Private Sub evaluateResponse()

        Dim LoggerDataRequest As New structs.LoggerDataRequest
        Timer1.Enabled = False

        Select Case BitConverter.ToInt16(Me.lastReceive, 4)
            Case &H1E1
                Dim LoggerCheck As structs.LoggerCheck = ByteConvert.ToStruct(Me.lastReceive, GetType(structs.LoggerCheck))

                lw_receive.Items.Add("-> receive LoggerCheck")
                lw_receive.Items.Add("LoggerState=" + Str(LoggerCheck.LoggerState))
                lw_receive.Items.Add("MemorySize=" + Str(LoggerCheck.MemorySize))
                lw_receive.Items.Add("MemoryProgress=" + Str(LoggerCheck.MemoryProgress))

                If LoggerCheck.LoggerState <> 4 Then
                    lw_receive.Items.Add("")
                    lw_receive.Items.Add("<- send LoggerCheck")
                    Me.sb_status.Text = "Checking Logger Memory"

                    If LoggerCheck.LoggerState > 2 Then
                        Me.ProgressBar1.Maximum = LoggerCheck.MemorySize
                        Me.ProgressBar1.Value = LoggerCheck.MemoryProgress
                    End If

                    Dim cmd As Byte() = ByteConvert.ToBytes(LoggerCheck, GetType(structs.LoggerCheck))
                    Me.TCP_Client.Send(cmd, cmd.Length, SocketFlags.None)
                Else
                    LoggerDataRequest.Start_1 = 0
                    LoggerDataRequest.Start_2 = 0
                    LoggerDataRequest.StructType = &H1E2
                    LoggerDataRequest.StructLength = 8


                    Dim cmd As Byte() = ByteConvert.ToBytes(LoggerDataRequest, GetType(structs.LoggerDataRequest))
                    Me.TCP_Client.Send(cmd, cmd.Length, SocketFlags.None)

                    lw_receive.Items.Add("")
                    lw_receive.Items.Add("<- send LoggerDataRequest")
                End If
            Case &H1E2
                Dim LoggerDataSet As structs.LoggerDataSet = ByteConvert.ToStruct(Me.lastReceive, GetType(structs.LoggerDataSet))

                Me.sb_status.Text = "Loading Datasets from Logger"

                Me.ProgressBar1.Maximum = LoggerDataSet.MaxCount
                Me.ProgressBar1.Value = LoggerDataSet.ProcessCount


                lw_receive.Items.Add("-> receive LoggerDataSet")
                lw_receive.Items.Add("MaxCount=" + Str(LoggerDataSet.MaxCount))
                lw_receive.Items.Add("ProcessCount=" + Str(LoggerDataSet.ProcessCount))

                Dim offset As TimeSpan = New TimeSpan(0, 0, 0, LoggerDataSet.TimeSecs + 3600 * Integer.Parse(ed_utcoffset.Text), 0)
                lw_receive.Items.Add("Time=" + baseDate.Add(offset).ToString())

                lw_receive.Items.Add("TimeMSecs=" + Str(LoggerDataSet.TimeMSecs))
                lw_receive.Items.Add("InputState=" + Hex(LoggerDataSet.InputState))
                lw_receive.Items.Add("OutputState=" + Hex(LoggerDataSet.OutputState))
                lw_receive.Items.Add("Alarms=" + Hex(LoggerDataSet.Alarms))
                lw_receive.Items.Add("CounterValue0=" + Str(LoggerDataSet.CounterValue(0)))
                lw_receive.Items.Add("CounterValue1=" + Str(LoggerDataSet.CounterValue(1)))
                lw_receive.Items.Add("CounterValue2=" + Str(LoggerDataSet.CounterValue(2)))
                lw_receive.Items.Add("CounterValue3=" + Str(LoggerDataSet.CounterValue(3)))
                lw_receive.Items.Add("CounterValue4=" + Str(LoggerDataSet.CounterValue(4)))
                lw_receive.Items.Add("CounterValue5=" + Str(LoggerDataSet.CounterValue(5)))

                lw_receive.Items.Add("ErrorCounter0=" + Str(LoggerDataSet.CounterError(0)))
                lw_receive.Items.Add("ErrorCounter1=" + Str(LoggerDataSet.CounterError(1)))
                lw_receive.Items.Add("ErrorCounter2=" + Str(LoggerDataSet.CounterError(2)))

            Case &H1E3
                Dim LoggerNoAccess As structs.LoggerNoAccess = ByteConvert.ToStruct(Me.lastReceive, GetType(structs.LoggerNoAccess))

                Me.sb_status.Text = "Access Denied"
                lw_receive.Items.Add("-> receive LoggerNoAccess")
                lw_receive.Items.Add("LoggerState=" + Str(LoggerNoAccess.LoggerState))
        End Select
        lw_receive.Items.Add("")
        lw_receive.Items(lw_receive.Items.Count - 1).EnsureVisible()
        Timer1.Enabled = True

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.ed_year0.Text = Now.Year
        Me.ed_month0.Text = Now.Month
        Me.ed_year1.Text = Now.Year
        Me.ed_month1.Text = Now.Month
        Me.ed_day1.Text = Now.Day
        Me.ed_hour1.Text = Now.Hour
        Me.ed_minute1.Text = Now.Minute
        Me.ed_second1.Text = Now.Second

        Me.lw_receive.Columns.Add("Received Data", Me.lw_receive.Width - 10, HorizontalAlignment.Left)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Me.Timer1.Enabled = False
        Me.ProgressBar1.Value = Me.ProgressBar1.Maximum
        Me.sb_status.Text = "Timeout - Connection closed"
        bt_connect.Enabled = True
        closeConnection()
    End Sub
End Class
